
#include "V_M_UC.h"
#include "str.h"
#include "sys_varargs.h"
#include "mem.h"

#if USE_varargs

/*++ * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
* CALL:
*   Blk * str_bldstr(va_alist)
*   	va_dcl
*
* DESCRIPTION:
*
* Make a string structure from a list of null-terminated strings.
* The list must be terminated by a null pointer.
*
* AUTHOR: John Chambers.
*
* CHANGES:
++*/
FCT Blk * str_bldstr(va_alist)
	va_dcl
{	int  i, n;
	Blk *dst=0;		/* Output string */
	char* cp;
	va_list ap;
	Fenter("str_bldstr");

	va_start(ap);
	dst = va_arg(ap,Blk*);

	dst->l = 0;
	while (cp = va_arg(ap,char*)) {

		if (!AppBlk(dst,cp,-1)) Fail;

	}
	va_end(ap);
done:

	Fexit;
	return dst;
fail:
	Fexit;
	return 0;
}
#endif

