#ifndef   sys_types_h
/*
* The  turkeys  just  can't  get their act together for the various "standard"
* types used in the system libraries.  This header file should make sure  that
* all the following types are defined:
*
*  size_t time_t u_char uchar u_short Ushort u_int Uint u_long Ulong
*
* Unfortunately,  vendors  like to put them in funny places, and/or not define
* all of them.  Maybe it's easiest to just #define them yourself!
*/
#if !defined(sys_types_h) && defined(TNV3)
static char sys_types[] = "TNV3";
#include "/usr/include/bsd/sys/types.h"
#define sys_types_h
#endif

#if  !defined(sys_types_h) && defined(SYS5)
static char sys_types[] = "SYS5";
#include <sys/types.h>
#define u_char	unsigned char
#define u_int	unsigned int
#define u_long	unsigned long
#define u_short	unsigned short
#define sys_types_h
#endif

#ifndef   local_h
#include "local.h"
#endif

#if !defined(sys_types_h) && defined(SOLARIS)
static char sys_types[] = "SOLARIS";
#undef Uint
#include <sys/types.h>
#ifndef uchar
#define uchar	unsigned char
#endif
#ifndef Uint
#define Uint	unsigned int
#endif
#ifndef Ulong
#define Ulong	unsigned long
#endif
#ifndef Ushort
#define Ushort	unsigned short
#endif
#define sys_types_h
#endif

#if !defined(sys_types_h) && defined(Darwin)
static char sys_types[] = "Darwin";
#include <sys/types.h>
#ifndef Ulong
#define Ulong	unsigned long
#define ulong	unsigned long
#endif
#define sys_types_h
#endif

#if !defined(sys_types_h)
static char sys_types[] = "default";
#include <sys/types.h>
#ifndef uchar
#define uchar	unsigned char
#endif
#ifndef Uint
#define Uint	unsigned int
#endif
#ifndef Ulong
#define Ulong	unsigned long
#endif
#ifndef Ushort
#define Ushort	unsigned short
#endif
#define sys_types_h
#endif

/*
* Here are some pseudo-types (abbreviations) that come in  handy  when
* we  want  to  specify types by the number of bits.  This offends the
* theoreticians, of course, but when writing low-level code, you often
* have no alternative.  Most vendors don't define these.
*/
#ifndef I8
#define I8 char
#endif
#ifndef I16
#define I16 short
#endif
#ifndef I32
#define I32 long
#endif
#ifndef U8
#define U8 unsigned char
#endif
#ifndef U16
#define U16 unsigned short
#endif
#ifndef U32
#define U32 unsigned long
#endif

#endif
