:i	static char d_bcopy_sccs_id[] = "%W% %G%";
:1#include "V.h"
/*
* Copy n bytes from src to dst; return nothing.  Note that  there  are
* often much more efficient ways to implement this, but this C version
* is portable.
*/

#ifndef Bcopy
void   Bcopy(src,dst,n) char *src, *dst; {while (n-- > 0) *dst++ = *src++;}
#endif

/*
* Here's our real debug version of bcopy(), which may call the library
* routine, or may invoke the above portable version.
*/
void d_bcopy(src,dst,n)
	char *src, *dst;
{
#if defined(USE_bcopy) && USE_bcopy > 1
	bcopy(src,dst,n);	/* Use the library bcopy() */
#else	/* USE_bcopy */
:f	Fenter("d_bcopy");
	if ((dst > src) && (dst < (src + n))) {
:9		V9 "Overlap: %08X lies within [%08X,%08X]",dst,src,src+n D;
		while (n-- > 0) dst[n] = src[n];
	} else if (dst != src) {
:9		V9 "Disjoint: %08X lies outside [%08X,%08X]",dst,src,src+n D;
		while (n-- > 0) *dst++ = *src++;
:9	} else {
:9		V9 "No copy: %08X == %08X",dst,src D;
	}
#endif	/* USE_bcopy */
:f	FExit;
}

#if (!defined(HAS_bcopy)) || (HAS_bcopy == 0)
/*
* Here's our portable version of bcopy.  The if is to handle the  case
* of  overlap,  which  is actually only a problem if dst is inside the
* src block. If you know that you don't want to use the library bcopy,
* you  might  consider merging these routines, for a slight efficiency
* gain and somewhat smaller code.
*/
void   bcopy(src,dst,n) char *src, *dst;
{
	if ((dst > src) && (dst < (src + n))) {
:9		V9 "Overlap: %08X lies within [%08X,%08X]",dst,src,src+n D;
		while (n-- > 0) dst[n] = src[n];
	} else if (dst != src) {
:9		V9 "Disjoint: %08X lies outside [%08X,%08X]",dst,src,src+n D;
		while (n-- > 0) *dst++ = *src++;
:9	} else {
:9		V9 "No copy: %08X == %08X",dst,src D;
	}
}
#endif
