
#include "V_s_lc.h"
/*
* This is a debug wrapper for the close() system call. Note that we try to use
* syscall(SYS_close,f);  if  this  is defined, then we can also define our own
* close(f) routine to intercept all calls from other library  routines.   Note
* also  that  we  zero  out  the  flags  but  leave  the name intact.  This is
* intentional, so that debug messages can say what the files was  called  when
* it  was open.  But it means that later opens will have to free the space, or
* we will have a memory leak.
*/
#if defined(SYS_close)
close(f) {return syscall(SYS_close,f);}
#endif

d_close(f)
	int f;
{	int v=0;
	int e=0;
	File *fp;

	errno = 0;
	if (f < 0) {	/* Some systems bomb for f < 0 */
		errno = EBADF;
		v = -1;
		Fail;
	}
#if defined(USE_syscall) && defined(SYS_close)
	v = syscall(SYS_close,f);
#else
	v = close(f);
#endif
	e = errno;
	if (fp = d_openfile(f)) {
		fp->flgs = 0;
		fp->addr = 0;
		fp->port = 0;
	}
fail:
	V6s "close(%d)=%d [Err %d=%s=%s]",f,v,Errinfo D;
	errno = e;
	return v;
}
