
#include "V.h"
/*
* The inet_ntoa() function bombs out on the Sun 4.
* (How can someone mess up something this easy? ;-)
*/
char* inet_ntoa(x)
	U32 x;
{
static char d[16];

#if defined(USE_pthreads) && (USE_pthreads > 0)
	if (V_locking && use_pthreads) {
		pthread_lock_global_np();
		P6 "\t\t\tpthread_lock_global_np() in %s",Fctname D;
		fflush(Vout);
	}
#endif /*USE_pthreads*/
	sprintf(d,"%d.%d.%d.%d",
#ifdef BIGENDIAN
		(x >> 24) & 0x00FF,
		(x >> 16) & 0x00FF,
		(x >>  8) & 0x00FF,
		(x      ) & 0x00FF
#define ENDIAN
#endif
#ifdef LITTLENDIAN
		(x      ) & 0x00FF,
		(x >>  8) & 0x00FF,
		(x >> 16) & 0x00FF,
		(x >> 24) & 0x00FF
#define ENDIAN
#endif
#ifdef MIXEDENDIAN
		(x >>  8) & 0x00FF,
		(x      ) & 0x00FF,
		(x >> 24) & 0x00FF
		(x >> 16) & 0x00FF,
#define ENDIAN
#endif
#ifndef ENDIAN		/* Assume network order (which is BIGENDIAN) */
		(x >> 24) & 0x00FF,
		(x >> 16) & 0x00FF,
		(x >>  8) & 0x00FF,
		(x      ) & 0x00FF
#endif
	);
#if defined(USE_pthreads) && (USE_pthreads > 0)
	if (V_locking && use_pthreads) {
		P6 "\t\t\tpthread_unlock_global_np() in %s",Fctname D;
		fflush(Vout);
		pthread_unlock_global_np();
	}
#endif /*USE_pthreads*/
	V3 "### Warning, host byte order is unknown in inet_ntoa(), using network order." D;

	return(d);
}
